struc OHCI_OPREG
{
; Control and Status Partition
  .HcRevision            dd ?
  .HcControl             dd ?
  .HcCommandStatus       dd ?
  .HcInterruptStatus     dd ?
  .HcInterruptEnable     dd ?
  .HcInterruptDisable    dd ?
; Memory Pointer Partition
  .HcHCCA                dd ?
  .HcPeriodCurrentED     dd ?
  .HcControlHeadED       dd ?
  .HcControlCurrentED    dd ?
  .HcBulkHeadED          dd ?
  .HcBulkCurrentED       dd ?
  .HcDoneHead            dd ?
; Frame Counter Partition
  .HcFmInterval          dd ?
  .HcFmRemaining         dd ?
  .HcFmNumber            dd ?
  .HcPeriodicStart       dd ?
  .HcLSThreshold         dd ?
; Root Hub Partition
  .HcRhDescriptorA       dd ?
  .HcRhDescriptorB       dd ?
  .HcRhStatus            dd ?
  .HcRhPortStatus        dd ? ; pointer to Port Status array
}
virtual at 0
  OHCI_OPREG OHCI_OPREG
end virtual

struc OHCI_HCCA
{ .HccaInterruptTable    dd dup 32
  .HccaFrameNumber       dw ?
  .HccaPad1              dw ?
  .HccaDoneHead          dd ?
  .reserved              db dup 116 ; pad according to specification
  .wat                   db dup 4 ; really pad to 256 as spec only covers 252
}
virtual at 0
  OHCI_HCCA OHCI_HCCA
end virtual

OHCI_ED_HALTED = 1
OHCI_ED_TOGGLE = 2
;((1 << b)-1) << a
OHCI_ED_FUNC =  (1 shl 7) - 1
OHCI_ED_EP = (1 shl 4) - 7 ; WTF!?: recheck in spec
OHCI_ED_DIR = (1 shl 2) - 11 ; WTF!?: recheck in spec
OCHI_ED_LOWSPEED = 1 shl 13

struc OHCI_ED
{ .config               dd ?
  .tail                 dd ? ; Tail pointer
  .head                 dd ? ; Head pointer
  .next                 dd ? ; Next ED
}
virtual at 0
  OHCI_ED OHCI_ED
end virtual

struc OHCI_TD
{ .config               dd ?
  .current              dd ? ; current buffer pointer
  .next                 dd ? ; next TD
  .buf_end              dd ? ; Buffer end
}
virtual at 0
  OHCI_TD OHCI_TD
end virtual

; Bits 0 through 17 of .config won't be interpreted by the host controller
; (HC) and, after provessing the TD, the HC has to ensure those bits have
; the same state as before. So we are free to use those bits for our own
; purpose.

; Start OHCI controller
; ---------------------
; ohci_start(hci_t *hci)
proc ohci_start stdcall, hci:dword
endp

; Stop OHCI controller
; --------------------
; ohci_stop(hci_t *hci)
proc ohci_stop stdcall, hci:dword
endp

; Reset OHCI controller
; ---------------------
; ohci_reset(hci_t *hci)
proc ohci_reset stdcall, hci:dword
endp

; Take ownership of OHCI controller
; ---------------------------------
; ohci_take(hci_t *hci)
proc ohci_take stdcall, hci:dword
endp

; Create OHCI structure
; ---------------------
; hci_t *ohci_create()
proc ohci_create stdcall
endp

; Do OHCI initialization
; ----------------------
; ohci_init(hci_t *hci)
proc ohci_init stdcall, hci:dword
endp

; vim: ft=fasm

